<template>
	<div class="d-inline-flex">
		<v-btn class="px-4" @click="showConfirmationDialog = true" v-bind="$attrs">Delete</v-btn>

		<confirm-dialog
			v-model="showConfirmationDialog"
			:title="`Delete ${field.name}`"
			:error="hasError ? error : null"
			message="You will no longer be able to recover this field once you delete. Are you sure you want to delete?"
			button="Delete"
			button-color="error"
			:loading="isLoading"
			persistent
			@confirm="handleConfirmDelete"
			@cleanup="clearError"
		/>
	</div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from '@vue/composition-api';
import ConfirmDialog from '@/components/dialog/ConfirmDialog.vue';
import { useDeleteField } from '@/store/modules/fields';
import { Field } from '@/store/types';

export default defineComponent({
	components: { ConfirmDialog },
	inheritAttrs: false,
	props: {
		field: {
			type: Object as () => Field,
			required: true,
		},
	},
	setup(props, { root }) {
		const showConfirmationDialog = ref<boolean>(false);
		const { deleteField, clearError, isLoading, hasError, error: deleteError } = useDeleteField(root.$store);
		const error = computed<string>(
			() =>
				deleteError.value?.response?.data?.message ||
				'An error occurred while attempting to delete a field. Please try again.'
		);

		const handleConfirmDelete = async () => {
			clearError();

			const success = await deleteField(props.field.id);

			if (success) {
				root.$store.dispatch('resources/getAllResources');
				showConfirmationDialog.value = false;
			}
		};

		return {
			showConfirmationDialog,
			handleConfirmDelete,
			clearError,
			isLoading,
			hasError,
			error,
		};
	},
});
</script>

<style></style>
